import { Component, ViewEncapsulation, ChangeDetectionStrategy, Input, Injectable, ɵɵdefineInjectable, ɵɵinject, Pipe, NgModule } from '@angular/core';
import { assign, isString, reduce, get, omit, pick, size } from 'lodash-es';
import { HttpClient, HttpClientModule } from '@angular/common/http';
import { BehaviorSubject, of } from 'rxjs';
import { map, distinctUntilChanged, catchError, finalize } from 'rxjs/operators';
import { __spread } from 'tslib';
import { CommonModule } from '@angular/common';
import { DomSanitizer } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/styles-loader-raw/styles-loader-raw.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StylesLoaderRawComponent = /** @class */ (function () {
    function StylesLoaderRawComponent() {
        this.items = [];
        this._ = { assign: assign, isString: isString, reduce: reduce };
        this.trackByValue = (/**
         * @param {?} index
         * @param {?} value
         * @return {?}
         */
        function (index, value) { return value; });
    }
    Object.defineProperty(StylesLoaderRawComponent.prototype, "Items", {
        get: /**
         * @return {?}
         */
        function () {
            return this.items;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StylesLoaderRawComponent.prototype, "Collection", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            var _this = this;
            this.items = Object.values(this._.reduce(value, (/**
             * @param {?} items
             * @param {?} url
             * @return {?}
             */
            function (items, url) {
                var _a;
                return (!!url && _this._.isString(url) && _this._.assign(items, (_a = {}, _a[url] = url, _a))) || items;
            }), {}));
        },
        enumerable: true,
        configurable: true
    });
    StylesLoaderRawComponent.decorators = [
        { type: Component, args: [{
                    selector: 'styles-loader-raw',
                    template: "\n    <ng-container *ngIf=\"!!Items?.length\">\n      <ng-container *ngFor=\"let value of Items; trackBy: trackByValue\">\n        <ng-container *ngIf=\"!!value\">\n          <link async rel=\"stylesheet\" [attr.data-url]=\"value\" [href]=\"value | safeUrl\" />\n        </ng-container>\n      </ng-container>\n    </ng-container>\n  ",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    StylesLoaderRawComponent.propDecorators = {
        Collection: [{ type: Input }]
    };
    return StylesLoaderRawComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    StylesLoaderRawComponent.prototype.items;
    /** @type {?} */
    StylesLoaderRawComponent.prototype._;
    /** @type {?} */
    StylesLoaderRawComponent.prototype.trackByValue;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/enums/style-handling-mode.enum.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @enum {string} */
var StyleHandlingMode = {
    PassThrough: "PassThrough",
    VerifiedPassThrough: "VerifiedPassThrough",
    Literal: "Literal",
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/services/styles-loader.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StylesLoaderService = /** @class */ (function () {
    function StylesLoaderService(http) {
        var _this = this;
        this.http = http;
        this.loadingStylesSubscription = new BehaviorSubject({});
        this.loadingStyles$ = this.loadingStylesSubscription.asObservable();
        this._ = { assign: assign, get: get, isString: isString, omit: omit, pick: pick, size: size };
        this.isStyleLoading = (/**
         * @param {?} url
         * @return {?}
         */
        function (url) { return !!_this._.get(_this.loadingStylesSubscription.getValue(), url); });
        this.isStyleLoading$ = (/**
         * @param {?} url
         * @return {?}
         */
        function (url) {
            return _this.loadingStyles$.pipe(map((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return !!_this._.get(x, url); })), distinctUntilChanged());
        });
        this.areStylesLoading = (/**
         * @param {?} urls
         * @return {?}
         */
        function (urls) { return !!_this._.size(_this._.pick(_this.loadingStylesSubscription.getValue(), urls)); });
        this.areStylesLoading$ = (/**
         * @param {?} urls
         * @return {?}
         */
        function (urls) {
            return _this.loadingStyles$.pipe(map((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return !!_this._.size(_this._.pick(x, urls)); })), distinctUntilChanged());
        });
        this.removeFromLoading = (/**
         * @param {?} url
         * @return {?}
         */
        function (url) {
            return _this.loadingStylesSubscription.next(_this._.omit(_this.loadingStylesSubscription.getValue(), url));
        });
        this.getStyle$ = (/**
         * @param {?} url
         * @param {?=} styleHandlingMode
         * @return {?}
         */
        function (url, styleHandlingMode) {
            var _a;
            if (!(!!url && _this._.isString(url)) || _this.isStyleLoading(url)) {
                return of(null);
            }
            /** @type {?} */
            var shm = _this._.get(StyleHandlingMode, styleHandlingMode, StyleHandlingMode.VerifiedPassThrough);
            if (shm === StyleHandlingMode.PassThrough) {
                return of(url);
            }
            _this.loadingStylesSubscription.next(_this._.assign({}, _this.loadingStylesSubscription.getValue(), (_a = {}, _a[url] = url, _a)));
            /** @type {?} */
            var request = _this.http.get(url, { responseType: 'blob' });
            return (shm === StyleHandlingMode.Literal //
                ? request.pipe(map((/**
                 * @param {?} result
                 * @return {?}
                 */
                function (result) { return URL.createObjectURL(result); })))
                : request.pipe(map((/**
                 * @return {?}
                 */
                function () { return url; })))).pipe(catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                console.error(error);
                return of(null);
            })), finalize((/**
             * @return {?}
             */
            function () { return _this.removeFromLoading(url); })));
        });
    }
    StylesLoaderService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    StylesLoaderService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    /** @nocollapse */ StylesLoaderService.ngInjectableDef = ɵɵdefineInjectable({ factory: function StylesLoaderService_Factory() { return new StylesLoaderService(ɵɵinject(HttpClient)); }, token: StylesLoaderService, providedIn: "root" });
    return StylesLoaderService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    StylesLoaderService.prototype.loadingStylesSubscription;
    /** @type {?} */
    StylesLoaderService.prototype.loadingStyles$;
    /** @type {?} */
    StylesLoaderService.prototype._;
    /** @type {?} */
    StylesLoaderService.prototype.isStyleLoading;
    /** @type {?} */
    StylesLoaderService.prototype.isStyleLoading$;
    /** @type {?} */
    StylesLoaderService.prototype.areStylesLoading;
    /** @type {?} */
    StylesLoaderService.prototype.areStylesLoading$;
    /**
     * @type {?}
     * @private
     */
    StylesLoaderService.prototype.removeFromLoading;
    /** @type {?} */
    StylesLoaderService.prototype.getStyle$;
    /**
     * @type {?}
     * @private
     */
    StylesLoaderService.prototype.http;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/styles-loader/styles-loader.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StylesLoaderComponent = /** @class */ (function () {
    function StylesLoaderComponent(loaderService) {
        this.loaderService = loaderService;
        this.items = [];
        this._ = { assign: assign, reduce: reduce, isString: isString, pick: pick, get: get };
        this.trackByKey = (/**
         * @param {?} index
         * @param {?} __1
         * @return {?}
         */
        function (index, _a) {
            var _b = _a.key, key = _b === void 0 ? "" + index : _b;
            return key;
        });
    }
    Object.defineProperty(StylesLoaderComponent.prototype, "Items", {
        get: /**
         * @return {?}
         */
        function () {
            return this.items;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(StylesLoaderComponent.prototype, "Config", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            var _this = this;
            var _a = this._.pick(value, ['collection', 'handling']), collection = _a.collection, handling = _a.handling;
            this.items = Object.values(this._.reduce(collection, (/**
             * @param {?} items
             * @param {?} url
             * @return {?}
             */
            function (items, url) {
                var _a;
                return (!!url &&
                    _this._.isString(url) &&
                    _this._.assign(items, (_a = {},
                        _a[url] = {
                            key: url,
                            url: url,
                            $: _this.loaderService.getStyle$(url, _this._.get(handling, url))
                        },
                        _a))) ||
                    items;
            }), {}));
        },
        enumerable: true,
        configurable: true
    });
    StylesLoaderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'styles-loader',
                    template: "\n    <ng-container *ngIf=\"!!Items?.length\">\n      <ng-container *ngFor=\"let obj of Items; trackBy: trackByKey\">\n        <ng-container *ngIf=\"obj.$ | async as style\">\n          <link async rel=\"stylesheet\" [attr.data-url]=\"obj.url\" [href]=\"style | safeUrl\" />\n        </ng-container>\n      </ng-container>\n    </ng-container>\n  ",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    /** @nocollapse */
    StylesLoaderComponent.ctorParameters = function () { return [
        { type: StylesLoaderService }
    ]; };
    StylesLoaderComponent.propDecorators = {
        Config: [{ type: Input }]
    };
    return StylesLoaderComponent;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    StylesLoaderComponent.prototype.items;
    /** @type {?} */
    StylesLoaderComponent.prototype._;
    /** @type {?} */
    StylesLoaderComponent.prototype.trackByKey;
    /**
     * @type {?}
     * @private
     */
    StylesLoaderComponent.prototype.loaderService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/interfaces/styles-loader-config.interface.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function StylesLoaderConfig() { }
if (false) {
    /** @type {?} */
    StylesLoaderConfig.prototype.collection;
    /** @type {?|undefined} */
    StylesLoaderConfig.prototype.handling;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/pipes/safe-url/safe-url.pipe.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SafeUrlPipe = /** @class */ (function () {
    function SafeUrlPipe(sanitizer) {
        var _this = this;
        this.sanitizer = sanitizer;
        this.transform = (/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return _this.sanitizer.bypassSecurityTrustResourceUrl(value); });
    }
    SafeUrlPipe.decorators = [
        { type: Pipe, args: [{
                    name: 'safeUrl'
                },] }
    ];
    /** @nocollapse */
    SafeUrlPipe.ctorParameters = function () { return [
        { type: DomSanitizer }
    ]; };
    return SafeUrlPipe;
}());
if (false) {
    /** @type {?} */
    SafeUrlPipe.prototype.transform;
    /**
     * @type {?}
     * @private
     */
    SafeUrlPipe.prototype.sanitizer;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-fi-styles-loader.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var components = [StylesLoaderComponent, StylesLoaderRawComponent];
var NgxFiStylesLoaderModule = /** @class */ (function () {
    function NgxFiStylesLoaderModule() {
    }
    NgxFiStylesLoaderModule.decorators = [
        { type: NgModule, args: [{
                    declarations: __spread(components, [SafeUrlPipe]),
                    entryComponents: components,
                    exports: components,
                    imports: [CommonModule, HttpClientModule],
                    providers: [StylesLoaderService]
                },] }
    ];
    return NgxFiStylesLoaderModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-fi-styles-loader.testing-module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StylesLoaderMockComponent = /** @class */ (function () {
    function StylesLoaderMockComponent() {
        this.Items = [];
    }
    StylesLoaderMockComponent.decorators = [
        { type: Component, args: [{
                    selector: 'styles-loader',
                    template: 'styles-loader'
                }] }
    ];
    StylesLoaderMockComponent.propDecorators = {
        Config: [{ type: Input }]
    };
    return StylesLoaderMockComponent;
}());
if (false) {
    /** @type {?} */
    StylesLoaderMockComponent.prototype.Items;
    /** @type {?} */
    StylesLoaderMockComponent.prototype.Config;
}
var StylesLoaderRawMockComponent = /** @class */ (function () {
    function StylesLoaderRawMockComponent() {
    }
    StylesLoaderRawMockComponent.decorators = [
        { type: Component, args: [{
                    selector: 'styles-loader-raw',
                    template: 'styles-loader-raw'
                }] }
    ];
    StylesLoaderRawMockComponent.propDecorators = {
        Collection: [{ type: Input }]
    };
    return StylesLoaderRawMockComponent;
}());
if (false) {
    /** @type {?} */
    StylesLoaderRawMockComponent.prototype.Items;
    /** @type {?} */
    StylesLoaderRawMockComponent.prototype.Collection;
}
var StylesLoaderMockService = /** @class */ (function () {
    function StylesLoaderMockService() {
        this.loadingStyles$ = new BehaviorSubject({});
        this.isStyleLoading = (/**
         * @param {?} url
         * @return {?}
         */
        function (url) { return false; });
        this.isStyleLoading$ = (/**
         * @param {?} url
         * @return {?}
         */
        function (url) { return of(false); });
        this.areStylesLoading = (/**
         * @param {?} urls
         * @return {?}
         */
        function (urls) { return false; });
        this.areStylesLoading$ = (/**
         * @param {?} urls
         * @return {?}
         */
        function (urls) { return of(false); });
        this.getStyle$ = (/**
         * @param {?} url
         * @param {?=} styleHandlingMode
         * @return {?}
         */
        function (url, styleHandlingMode) { return of(null); });
    }
    return StylesLoaderMockService;
}());
if (false) {
    /** @type {?} */
    StylesLoaderMockService.prototype.loadingStyles$;
    /** @type {?} */
    StylesLoaderMockService.prototype.isStyleLoading;
    /** @type {?} */
    StylesLoaderMockService.prototype.isStyleLoading$;
    /** @type {?} */
    StylesLoaderMockService.prototype.areStylesLoading;
    /** @type {?} */
    StylesLoaderMockService.prototype.areStylesLoading$;
    /** @type {?} */
    StylesLoaderMockService.prototype.getStyle$;
}
/** @type {?} */
var components$1 = [StylesLoaderMockComponent, StylesLoaderRawMockComponent];
var NgxFiStylesLoaderTestingModule = /** @class */ (function () {
    function NgxFiStylesLoaderTestingModule() {
    }
    NgxFiStylesLoaderTestingModule.decorators = [
        { type: NgModule, args: [{
                    declarations: components$1,
                    entryComponents: components$1,
                    exports: __spread(components$1),
                    providers: [
                        {
                            provide: StylesLoaderService,
                            useClass: StylesLoaderMockService
                        }
                    ]
                },] }
    ];
    return NgxFiStylesLoaderTestingModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-fi-styles-loader.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxFiStylesLoaderModule, NgxFiStylesLoaderTestingModule, StyleHandlingMode, StylesLoaderComponent, StylesLoaderMockComponent, StylesLoaderMockService, StylesLoaderRawComponent, StylesLoaderRawMockComponent, StylesLoaderService, SafeUrlPipe as ɵa };
//# sourceMappingURL=ngx-fi-styles-loader.js.map
