import { IStylesLoaderComponent } from '../../interfaces/istyles-loader-component.interface';
import { StyleItem } from '../../interfaces/style-item.interface';
import { StylesLoaderConfig } from '../../interfaces/styles-loader-config.interface';
import { StylesLoaderService } from '../../services/styles-loader.service';
export declare class StylesLoaderComponent implements IStylesLoaderComponent {
    private loaderService;
    private items;
    readonly _: {
        assign: {
            <TObject, TSource>(object: TObject, source: TSource): TObject & TSource;
            <TObject, TSource1, TSource2>(object: TObject, source1: TSource1, source2: TSource2): TObject & TSource1 & TSource2;
            <TObject, TSource1, TSource2, TSource3>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3): TObject & TSource1 & TSource2 & TSource3;
            <TObject, TSource1, TSource2, TSource3, TSource4>(object: TObject, source1: TSource1, source2: TSource2, source3: TSource3, source4: TSource4): TObject & TSource1 & TSource2 & TSource3 & TSource4;
            <TObject>(object: TObject): TObject;
            (object: any, ...otherArgs: any[]): any;
        };
        reduce: {
            <T, TResult>(collection: T[], callback: import("lodash").MemoListIterator<T, TResult, T[]>, accumulator: TResult): TResult;
            <T, TResult>(collection: ArrayLike<T>, callback: import("lodash").MemoListIterator<T, TResult, ArrayLike<T>>, accumulator: TResult): TResult;
            <T extends object, TResult>(collection: T, callback: import("lodash").MemoObjectIterator<T[keyof T], TResult, T>, accumulator: TResult): TResult;
            <T>(collection: T[], callback: import("lodash").MemoListIterator<T, T, T[]>): T;
            <T>(collection: ArrayLike<T>, callback: import("lodash").MemoListIterator<T, T, ArrayLike<T>>): T;
            <T extends object>(collection: T, callback: import("lodash").MemoObjectIterator<T[keyof T], T[keyof T], T>): T[keyof T];
        };
        isString: (value?: any) => value is string;
        pick: {
            <T extends object, U extends keyof T>(object: T, ...props: import("lodash").Many<U>[]): Pick<T, U>;
            <T>(object: T, ...props: import("lodash").Many<string | number | symbol>[]): Partial<T>;
        };
        get: {
            <TObject extends object, TKey extends keyof TObject>(object: TObject, path: TKey | [TKey]): TObject[TKey];
            <TObject extends object, TKey extends keyof TObject>(object: TObject, path: TKey | [TKey]): TObject[TKey];
            <TObject extends object, TKey extends keyof TObject, TDefault>(object: TObject, path: TKey | [TKey], defaultValue: TDefault): TDefault | Exclude<TObject[TKey], undefined>;
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1]>(object: TObject, path: [TKey1, TKey2]): TObject[TKey1][TKey2];
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1]>(object: TObject, path: [TKey1, TKey2]): TObject[TKey1][TKey2];
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1], TDefault>(object: TObject, path: [TKey1, TKey2], defaultValue: TDefault): TDefault | Exclude<TObject[TKey1][TKey2], undefined>;
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1], TKey3 extends keyof TObject[TKey1][TKey2]>(object: TObject, path: [TKey1, TKey2, TKey3]): TObject[TKey1][TKey2][TKey3];
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1], TKey3 extends keyof TObject[TKey1][TKey2]>(object: TObject, path: [TKey1, TKey2, TKey3]): TObject[TKey1][TKey2][TKey3];
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1], TKey3 extends keyof TObject[TKey1][TKey2], TDefault>(object: TObject, path: [TKey1, TKey2, TKey3], defaultValue: TDefault): TDefault | Exclude<TObject[TKey1][TKey2][TKey3], undefined>;
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1], TKey3 extends keyof TObject[TKey1][TKey2], TKey4 extends keyof TObject[TKey1][TKey2][TKey3]>(object: TObject, path: [TKey1, TKey2, TKey3, TKey4]): TObject[TKey1][TKey2][TKey3][TKey4];
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1], TKey3 extends keyof TObject[TKey1][TKey2], TKey4 extends keyof TObject[TKey1][TKey2][TKey3]>(object: TObject, path: [TKey1, TKey2, TKey3, TKey4]): TObject[TKey1][TKey2][TKey3][TKey4];
            <TObject extends object, TKey1 extends keyof TObject, TKey2 extends keyof TObject[TKey1], TKey3 extends keyof TObject[TKey1][TKey2], TKey4 extends keyof TObject[TKey1][TKey2][TKey3], TDefault>(object: TObject, path: [TKey1, TKey2, TKey3, TKey4], defaultValue: TDefault): TDefault | Exclude<TObject[TKey1][TKey2][TKey3][TKey4], undefined>;
            <T>(object: import("lodash").NumericDictionary<T>, path: number): T;
            <T>(object: import("lodash").NumericDictionary<T>, path: number): T;
            <T, TDefault>(object: import("lodash").NumericDictionary<T>, path: number, defaultValue: TDefault): T | TDefault;
            <TDefault>(object: null, path: import("lodash").Many<string | number | symbol>, defaultValue: TDefault): TDefault;
            (object: null, path: import("lodash").Many<string | number | symbol>): undefined;
            (object: any, path: import("lodash").Many<string | number | symbol>, defaultValue?: any): any;
        };
    };
    readonly Items: StyleItem[];
    Config: StylesLoaderConfig;
    constructor(loaderService: StylesLoaderService);
    trackByKey: (index: number, { key }: {
        key?: string;
    }) => string;
}
