import { Observable } from 'rxjs';
import { StyleHandlingMode } from './enums/style-handling-mode.enum';
import { IStylesLoaderComponent } from './interfaces/istyles-loader-component.interface';
import { IStylesLoaderRawComponent } from './interfaces/istyles-loader-raw-component.interface';
import { IStylesLoaderService } from './interfaces/istyles-loader-service.interface';
import { StyleItem } from './interfaces/style-item.interface';
import { StylesLoaderConfig } from './interfaces/styles-loader-config.interface';
export declare class StylesLoaderMockComponent implements IStylesLoaderComponent {
    Items: StyleItem[];
    Config: StylesLoaderConfig;
}
export declare class StylesLoaderRawMockComponent implements IStylesLoaderRawComponent {
    Items: string[];
    Collection: string[];
}
export declare class StylesLoaderMockService implements IStylesLoaderService {
    loadingStyles$: Observable<{
        [key: string]: string;
    }>;
    isStyleLoading: (url: string) => boolean;
    isStyleLoading$: (url: string) => Observable<boolean>;
    areStylesLoading: (urls: string[]) => boolean;
    areStylesLoading$: (urls: string[]) => Observable<boolean>;
    getStyle$: (url: string, styleHandlingMode?: StyleHandlingMode) => Observable<string>;
}
export declare class NgxFiStylesLoaderTestingModule {
}
